/*
 * MIT License
 *
 * Copyright (c) 2022 Alexey Edelev <semlanik@gmail.com>
 *
 * This file is part of QtProtobuf project https://git.semlanik.org/semlanik/qtprotobuf
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this
 * software and associated documentation files (the "Software"), to deal in the Software
 * without restriction, including without limitation the rights to use, copy, modify,
 * merge, publish, distribute, sublicense, and/or sell copies of the Software, and
 * to permit persons to whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies
 * or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#pragma once

#include <QObject>
#include <QProtobufSerializer>

class QtProtobufMapTypesSerializationTest : public QObject
{
    Q_OBJECT
public:
    QtProtobufMapTypesSerializationTest() {
        qRegisterProtobufTypes();
    }
private slots:
    void init() {
        m_serializer.reset(new QProtobufSerializer);
    }
    void SimpleFixed32StringMapSerializeTest();
    void SimpleSFixed32StringMapSerializeTest();
    void SimpleInt32StringMapSerializeTest();
    void SimpleSInt32StringMapSerializeTest();
    void SimpleUInt32StringMapSerializeTest();
    void SimpleFixed64StringMapSerializeTest();
    void SimpleSFixed64StringMapSerializeTest();
    void SimpleInt64StringMapSerializeTest();
    void SimpleSInt64StringMapSerializeTest();
    void SimpleUInt64StringMapSerializeTest();
    void SimpleStringStringMapSerializeTest();
    void SimpleFixed32ComplexMapSerializeTest();
    void SimpleSFixed32ComplexMapSerializeTest();
    void SimpleInt32ComplexMapSerializeTest();
    void SimpleSInt32ComplexMapSerializeTest();
    void SimpleUInt32ComplexMapSerializeTest();
    void SimpleFixed64ComplexMapSerializeTest();
    void SimpleSFixed64ComplexMapSerializeTest();
    void SimpleInt64ComplexMapSerializeTest();
    void SimpleSInt64ComplexMapSerializeTest();
    void SimpleUInt64ComplexMapSerializeTest();
    void SimpleStringComplexMapSerializeTest();
private:
    std::unique_ptr<QProtobufSerializer> m_serializer;
};
